From: Brian Harring <ferringb@gmail.com>
To: git@vger.kernel.org
Cc: spearce@spearce.org
Subject: [PATCH] fix hang in git fetch if pointed at a 0 length bundle
Date: Mon, 2 Jan 2012 17:13:52 -0800 [thread overview]
Message-ID: <20120103011352.GA13825@localhost> (raw)
git-repo if interupted at the exact wrong time will generate zero
length bundles- literal empty files. git-repo is wrong here, but
git fetch shouldn't effectively spin loop if pointed at a zero
length bundle.
Signed-off-by: Brian Harring <ferringb@chromium.org>
---
bundle.c | 2 +-
t/t5704-bundle.sh | 10 ++++++++++
2 files changed, 11 insertions(+), 1 deletions(-)
diff --git a/bundle.c b/bundle.c
index 4742f27..ac9cc20 100644
--- a/bundle.c
+++ b/bundle.c
@@ -31,7 +31,7 @@ static int strbuf_readline_fd(struct strbuf *sb, int fd)
while (1) {
char ch;
ssize_t len = xread(fd, &ch, 1);
- if (len < 0)
+ if (len <= 0)
return -1;
strbuf_addch(sb, ch);
if (ch == '\n')
diff --git a/t/t5704-bundle.sh b/t/t5704-bundle.sh
index 728ccd8..75ce5b8 100755
--- a/t/t5704-bundle.sh
+++ b/t/t5704-bundle.sh
@@ -53,4 +53,14 @@ test_expect_failure 'bundle --stdin <rev-list options>' '
'
+test_expect_success 'die if bundle file is empty' '
+
+ echo -n > empty-bundle
+ timeout 5 git fetch empty-bundle
+ ret=$?
+ [ $ret == 128 ] && return 0
+ return $ret
+
+'
+
test_done
--
1.7.8.2
next reply other threads:[~2012-01-03 1:14 UTC|newest]
Thread overview: 6+ messages / expand[flat|nested] mbox.gz Atom feed top
2012-01-03 1:13 Brian Harring [this message]
2012-01-03 8:35 ` [PATCH] fix hang in git fetch if pointed at a 0 length bundle Johannes Sixt
2012-01-03 12:07 ` Nguyen Thai Ngoc Duy
2012-01-03 20:11 ` Junio C Hamano
2012-01-03 13:46 ` Brian Harring
2012-01-03 20:13 ` Junio C Hamano
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20120103011352.GA13825@localhost \
--to=ferringb@gmail.com \
--cc=git@vger.kernel.org \
--cc=spearce@spearce.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.